/* gxTar - Gnomified Archive Frontend
 * Copyright (C) 1998 Chris Rogers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option) 
 * any later version.
 *  
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
 * GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  
 * 02111-1307, USA.
 */

#include "menu_gtk.h"
#include <string.h>



void ShowDialog(); /*the definition is at the end*/


void file_quit_callback (GtkWidget *widget, gpointer data){quitArchive();}
void file_new_callback(GtkWidget *widget, gpointer data){newArchive();}
void file_open_callback(GtkWidget *widget, gpointer data){openfileArchive();}
void file_close_callback(GtkWidget *widget, gpointer data){closeArchive();}
void actions_add_callback(GtkWidget *widget, gpointer data){ addArchive();}
void actions_delete_callback(GtkWidget *widget, gpointer data){deleteArchive();}
void actions_extract_callback(GtkWidget *widget, gpointer data){extractArchive();}
void actions_view_callback(GtkWidget *widget, gpointer data){viewFile();}
void actions_select_callback(GtkWidget *widget, gpointer data){selectAll();}
void actions_deselect_callback(GtkWidget *widget, gpointer data){deselectAll();}
void options_configuration_callback(GtkWidget *widget, gpointer data){}
void help_about_callback(GtkWidget *widget, gpointer data){ShowDialog();}

/*forward decs */
void menus_init( GtkAccelGroup *group );
void menus_create(GtkItemFactoryEntry * entries, int nmenu_entries);




/*our menu's */

static GtkItemFactoryEntry menu_items[] =
  {
    {"/_File",                 NULL, NULL, 0, "<Branch>"},
    {"/File/_New Archive", "<control>N", file_new_callback, 0}, 
    {"/File/Open Archive", "<control>O", file_open_callback, 0}, 
    {"/File/Close Archive","<control>C" , file_close_callback, 0},
    {"/File/sep", NULL, NULL, 0,"<Separator>"},
    {"/File/Quit", "<control>Q", file_quit_callback, 0},
    {"/_Actions",                 NULL, NULL, 0, "<Branch>"},
    {"/Actions/Add", NULL, actions_add_callback, 0},
    {"/Actions/Delete", NULL,actions_delete_callback , 0},
    {"/Actions/Extract", NULL,actions_extract_callback , 0},
    {"/Actions/View", NULL,actions_view_callback , 0},
    {"/Actions/sep", NULL, NULL, 0, "<Separator>"},
    {"/Actions/Select All", NULL,actions_select_callback , 0},
    {"/Actions/Deselect All", NULL, actions_deselect_callback, 0},
    {"/_Options",                 NULL, NULL, 0, "<Branch>"},
    {"/Options/Configuration", NULL, options_configuration_callback, 0},
    {"/_Help",                 NULL, NULL, 0, "<Branch>"},
    {"/Help/About", NULL, help_about_callback, 0}
  };




/* calculate the number of menu_item's */
static int nmenu_items = sizeof(menu_items) / sizeof(menu_items[0]);
static int initialize = TRUE;
static GtkItemFactory *factory = NULL;

void get_main_menu(GtkWidget **menubar, GtkAccelGroup **group)
{
    if (initialize)
            menus_init( *group);
    
    if (menubar)
            *menubar = gtk_item_factory_get_widget( factory, "<Main>" );
}

void menus_init( GtkAccelGroup *group )
{
    if (initialize) {
        initialize = FALSE;
        
        factory = gtk_item_factory_new( GTK_TYPE_MENU_BAR, "<Main>", group );
        
        menus_create(menu_items, nmenu_items);
    }
}

void menus_create( GtkItemFactoryEntry * entries, int nmenu_entries )
{
    gtk_item_factory_create_items(factory, nmenu_entries, entries, NULL);
}



void menus_set_sensitive( char *path, int sensitive )
{
   GtkWidget *widget = NULL;

   widget = gtk_item_factory_get_widget( factory, path );
   if( widget )
       gtk_widget_set_sensitive( widget, sensitive );
   else
       g_warning("Unable to set sensitivity for menu which doesn't exist: %s", path);
}

GtkWidget *menus_get_item_widget( char *path )
{
   GtkWidget *widget = NULL;

   widget = gtk_item_factory_get_widget( factory, path );

   return( widget );
}




void createMenu(GtkWidget *frame)
{
  GtkWidget *menubar;
  GtkAccelGroup *accel;

  accel = gtk_accel_group_new();
  get_main_menu (&menubar, &accel);
  gtk_accel_group_attach( accel, GTK_OBJECT( frame ) );

  gtk_box_pack_start(GTK_BOX(frame), menubar, FALSE, TRUE, 0);
  gtk_widget_show(menubar);

}



/*About Dialog*/
void delete_about(GtkWidget *widget, GtkWidget *data)
{
  gtk_widget_destroy (GTK_WIDGET(data));
}

void ShowDialog() {

  GtkWidget *label;
  GtkWidget *button;
  GtkWidget *dialog_window;

  dialog_window = gtk_dialog_new();

  gtk_signal_connect (GTK_OBJECT (dialog_window), "destroy",
                      GTK_SIGNAL_FUNC(delete_about), dialog_window);
  
  gtk_window_set_title (GTK_WINDOW (dialog_window), "About");
  
  gtk_container_border_width (GTK_CONTAINER (dialog_window), 0);
  
  button = gtk_button_new_with_label ("OK");
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->action_area), button,
 FALSE, FALSE, 0);

  gtk_widget_grab_default (button);
 
  gtk_signal_connect (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (delete_about),  dialog_window);
  
  gtk_widget_show (button);
  
  label = gtk_label_new ("gxTar - Written by Chris Rogers\n(c)1998");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog_window)->vbox), label, FALSE, 
FALSE, 0);
  gtk_widget_show (label);

  
  gtk_widget_show (dialog_window);
  gtk_grab_add(dialog_window);

}
